- README

- Top Level Namespace
- Adler32
- ArgumentError
- Array
- Atomic
- Base64
  - Error
- Benchmark
  - BM
    - Job
    - Tms
  - IPS
    - Entry
    - Job
- BigFloat
- BigInt
- BigRational
- BitArray
- Bool
- Box
- Bytes
- Channel
  - Buffered
  - ClosedError
  - ReceiveAction
  - SelectAction
  - SendAction
  - Unbuffered
- Char
  - Reader
- Class
- Colorize
  - Object
  - ObjectExtensions
- Comparable
- Complex
- Concurrent
  - CanceledError
- CRC32
- Crypto
  - Bcrypt
    - Error
    - Password
  - Blowfish
  - Subtle
- CSV
  - Builder
    - Row
  - Error
  - Lexer
  - MalformedCSVError
  - Parser
  - Row
  - Token
    - Kind
- Debug
  - DWARF
    - Abbrev
      - Attribute
    - AT
    - FORM
    - Info
      - Value
    - LineNumbers
      - Register
      - Row
      - Sequence
    - LNE
    - LNS
    - Strings
    - TAG
  - ELF
    - Endianness
    - Error
    - Ident
    - Klass
    - Machine
    - OSABI
    - SectionHeader
      - Flags
      - Type
    - Type
- Deque
- Digest
  - Base
  - MD5
  - SHA1
- Dir
- DivisionByZero
- DL
- ECR
- Enum
- Enumerable
  - EmptyError
- ENV
- Errno
- Exception
- Fiber
- File
  - Stat
- FileUtils
- Flate
  - Error
  - Reader
  - Strategy
  - Writer
- Float
  - Primitive
- Float32
- Float64
- GC
  - Stats
- Gzip
  - Error
  - Header
  - Reader
  - Writer
- Hash
- HTML
- HTTP
  - Client
    - BodyType
    - Response
  - CompressHandler
  - ComputedContentTypeHeader
  - Cookie
  - Cookies
  - ErrorHandler
  - FormData
    - Builder
    - Error
    - FileMetadata
    - Parser
    - Part
  - Handler
    - Proc
  - Headers
  - LogHandler
  - Multipart
    - Builder
    - Error
    - Parser
  - Params
    - Builder
  - Request
  - Server
    - Context
    - RequestProcessor
    - Response
  - StaticFileHandler
    - DirectoryListing
  - WebSocket
  - WebSocketHandler
- Indexable
- IndexError
- INI
- Int
  - Primitive
  - Signed
  - Unsigned
- Int16
- Int32
- Int64
- Int8
- InvalidByteSequenceError
- IO
  - Buffered
  - ByteFormat
    - BigEndian
    - LittleEndian
    - NetworkEndian
    - SystemEndian
  - Delimited
  - EncodingOptions
  - EOFError
  - Error
  - FileDescriptor
  - Hexdump
  - Memory
  - MultiWriter
  - Seek
  - Sized
  - Timeout
- IPSocket
- Iterable
- Iterator
  - IteratorWrapper
  - Stop
- JSON
  - Any
  - Builder
    - ArrayState
    - DocumentEndState
    - DocumentStartState
    - ObjectState
    - StartState
    - State
  - Error
  - Lexer
  - ParseException
  - Parser
  - PullParser
  - Token
  - Type
- KeyError
- Levenshtein
  - Finder
- LLVM
  - ABI
    - AArch64
    - ArgKind
    - ArgType
    - ARM
    - FunctionType
    - X86
    - X86_64
      - RegClass
  - AtomicOrdering
  - AtomicRMWBinOp
  - Attribute
  - AttributeIndex
  - BasicBlock
  - BasicBlockCollection
  - Builder
  - CallConvention
  - CodeGenFileType
  - CodeGenOptLevel
  - CodeModel
  - Context
  - DIBuilder
  - DIFlags
  - DwarfTag
  - DwarfTypeEncoding
  - Function
  - FunctionCollection
  - FunctionPassManager
    - Runner
  - GenericValue
  - GlobalCollection
  - InstructionCollection
  - IntPredicate
  - JITCompiler
  - Linkage
  - MemoryBuffer
  - Module
  - ModuleFlag
  - ModulePassManager
  - ParameterCollection
  - PassManagerBuilder
  - PassRegistry
  - PhiTable
  - RealPredicate
  - RelocMode
  - Target
  - TargetData
  - TargetMachine
  - Type
    - Kind
  - Value
    - Kind
  - ValueMethods
  - VerifierFailureAction
- Logger
  - Formatter
  - Severity
- Markdown
  - HTMLRenderer
  - Parser
    - PrefixHeader
    - UnorderedList
  - Renderer
- Math
- Mutex
- NamedTuple
- Nil
- Number
  - Primitive
- OAuth
  - AccessToken
  - Consumer
  - Error
  - RequestToken
- OAuth2
  - AccessToken
    - Bearer
    - Mac
  - Client
  - Error
  - Session
- Object
- OpenSSL
  - Digest
    - Error
    - UnsupportedError
  - DigestBase
  - Error
  - HMAC
  - MD5
  - SHA1
  - SSL
    - Context
      - Client
      - Server
    - Error
    - ErrorType
    - Modes
    - Options
    - Socket
      - Client
      - Server
    - VerifyMode
    - X509VerifyFlags
- OptionParser
  - Exception
  - InvalidOption
  - MissingOption
- PartialComparable
- Pointer
  - Appender
- PrettyPrint
- Proc
- Process
  - Env
  - Status
  - Stdio
  - Tms
- Random
  - MT19937
- Range
- Readline
  - CompletionProc
  - KeyBindingProc
- Reference
- Reflect
- Regex
  - MatchData
  - Options
- SecureRandom
- Set
- Signal
- Slice
- Socket
  - Address
  - Addrinfo
  - Error
  - Family
  - IPAddress
  - Protocol
  - Server
  - Type
  - UNIXAddress
- Spec
  - Expectations
  - Methods
  - ObjectExtensions
- StaticArray
- String
  - Builder
  - RawConverter
- StringPool
- StringScanner
- Struct
- Symbol
- System
- TCPServer
- TCPSocket
- Tempfile
- Termios
  - AttributeSelection
  - BaudRate
  - ControlMode
  - InputMode
  - LineControl
  - LocalMode
  - OutputMode
- Time
  - DayOfWeek
  - EpochConverter
  - EpochMillisConverter
  - Format
    - Error
  - Kind
  - MonthSpan
  - Span
- Tuple
- TypeCastError
- UDPSocket
- UInt16
- UInt32
- UInt64
- UInt8
- Unicode
  - CaseOptions
- Union
- UNIXServer
- UNIXSocket
- URI
  - Error
- Value
- WeakRef
- XML
  - Attributes
  - AttributeType
  - Builder
  - Error
  - HTMLParserOptions
  - Namespace
  - Node
  - NodeSet
  - ParserOptions
  - Reader
  - SaveOptions
  - Type
  - XPathContext
- YAML
  - Any
  - Builder
  - Error
  - EventKind
  - ParseException
  - Parser
  - PullParser
  - Type
- Zip
  - CompressionMethod
  - Error
  - File
    - Entry
  - FileInfo
  - Reader
    - Entry
  - Writer
    - Entry
- Zlib
  - Error
  - Reader
  - Writer

# struct JSON::Any

- JSON::Any
- Struct
- Value
- Object

## Overview

`JSON::Any` is a convenient wrapper around all possible JSON types (`JSON::Type`) and can be used for traversing dynamic or unknown JSON structures.

    obj = JSON.parse(%({"access": [{"name": "mapping", "speed": "fast"}, {"name": "any", "speed": "slow"}]}))
    obj["access"][1]["name"].as_s  # => "any"
    obj["access"][1]["speed"].as_s # => "slow"

Note that methods used to traverse a JSON structure, `#[]`, `#[]?` and `#each`, always return a `JSON::Any` to allow further traversal. To convert them to `String`, `Int32`, etc., use the `as_` methods, such as `#as_s`, `#as_i`, which perform a type check against the raw underlying value. This means that invoking `#as_s` when the underlying value is not a String will raise: the value won't automatically be converted (parsed) to a `String`.

## Included Modules

- Enumerable(self)

## Defined in:

## Class Method Summary

- .new(raw : JSON::Type)

  Creates a `JSON::Any` that wraps the given `JSON::Type`.

- .new(pull : JSON::PullParser)

  Reads a `JSON::Any` value from the given pull parser.

## Instance Method Summary

- #==(other)

  Returns `true` if the raw object is equal to other.

- #==(other : JSON::Any)

  Returns `true` if both `self` and other's raw object are equal.

- #[](index : Int) : JSON::Any

  Assumes the underlying value is an `Array` and returns the element at the given index.

- #[](key : String) : JSON::Any

  Assumes the underlying value is a `Hash` and returns the element with the given key.

- #[]?(index : Int) : JSON::Any?

  Assumes the underlying value is an `Array` and returns the element at the given index, or `nil` if out of bounds.

- #[]?(key : String) : JSON::Any?

  Assumes the underlying value is a `Hash` and returns the element with the given key, or `nil` if the key is not present.

- #as_a : Array(Type)

  Checks that the underlying value is `Array`, and returns its value.

- #as_a? : Array(Type)?

  Checks that the underlying value is `Array`, and returns its value.

- #as_bool : Bool

  Checks that the underlying value is `Bool`, and returns its value.

- #as_bool? : Bool?

  Checks that the underlying value is `Bool`, and returns its value.

- #as_f : Float64

  Checks that the underlying value is `Float`, and returns its value as an `Float64`.

- #as_f32 : Float32

  Checks that the underlying value is `Float`, and returns its value as an `Float32`.

- #as_f32? : Float32?

  Checks that the underlying value is `Float`, and returns its value as an `Float32`.

- #as_f? : Float64?

  Checks that the underlying value is `Float`, and returns its value as an `Float64`.

- #as_h : Hash(String, Type)

  Checks that the underlying value is `Hash`, and returns its value.

- #as_h? : Hash(String, Type)?

  Checks that the underlying value is `Hash`, and returns its value.

- #as_i : Int32

  Checks that the underlying value is `Int`, and returns its value as an `Int32`.

- #as_i64 : Int64

  Checks that the underlying value is `Int`, and returns its value as an `Int64`.

- #as_i64? : Int64?

  Checks that the underlying value is `Int`, and returns its value as an `Int64`.

- #as_i? : Int32?

  Checks that the underlying value is `Int`, and returns its value as an `Int32`.

- #as_nil : Nil

  Checks that the underlying value is `Nil`, and returns `nil`.

- #as_s : String

  Checks that the underlying value is `String`, and returns its value.

- #as_s? : String?

  Checks that the underlying value is `String`, and returns its value.

- #each(&block)

  Assumes the underlying value is an `Array` or `Hash` and yields each of the elements or key/values, always as `JSON::Any`.

- #raw : JSON::Type

  Returns the raw underlying value, a `JSON::Type`.

- #size : Int

  Assumes the underlying value is an `Array` or `Hash` and returns its size.

### Instance methods inherited from module `Enumerable(self)`

all?(&block)
all? all?, any?(&block)
any? any?, chunks(&block : T -> U) forall U chunks, compact_map(&block) compact_map, count(&block)
count(item) count, cycle(n, &block)
cycle(&block) cycle, each(&block : T -> _) each, each_cons(count : Int, reuse = false, &block) each_cons, each_slice(count : Int, reuse = false, &block) each_slice, each_with_index(offset = 0, &block) each_with_index, each_with_object(obj, &block) each_with_object, find(if_none = nil, &block) find, first(count : Int)
first first, first? first?, flat_map(&block : T -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : T -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &block) forall U in_groups_of, includes?(obj) includes?, index(&block)
index(obj) index, index_by(&block : T -> U) forall U index_by, join(separator, io)
join(separator = "")
join(separator, io, &block)
join(separator = "", &block) join, map(&block : T -> U) forall U map, map_with_index(&block : T, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : T -> U) forall U max_by, max_by?(&block : T -> U) forall U max_by?, max_of(&block : T -> U) forall U max_of, max_of?(&block : T -> U) forall U max_of?, min min, min? min?, min_by(&block : T -> U) forall U min_by, min_by?(&block : T -> U) forall U min_by?, min_of(&block : T -> U) forall U min_of, min_of?(&block : T -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : T -> U) forall U minmax_by, minmax_by?(&block : T -> U) forall U minmax_by?, minmax_of(&block : T -> U) forall U minmax_of, minmax_of?(&block : T -> U) forall U minmax_of?, none?(&block)
none? none?, one?(&block) one?, partition(&block) partition, product(&block)
product(initial : Number, &block)
product
product(initial : Number) product, reduce(&block)
reduce(memo, &block) reduce, reject(&block : T -> ) reject, select(&block : T -> ) select, size size, skip(count : Int) skip, skip_while(&block) skip_while, sum(initial)
sum
sum(initial, &block)
sum(&block) sum, take_while(&block) take_while, to_a to_a, to_h to_h, to_set to_set

### Instance methods inherited from struct `Struct`

==(other : self) : Bool ==, hash : Int32 hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io) to_s

### Instance methods inherited from struct `Value`

==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try

### Class methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io) : self from_yaml

## Class Method Detail

def self.new(raw : JSON::Type) #

Creates a `JSON::Any` that wraps the given `JSON::Type`.

def self.new(pull : JSON::PullParser) #

Reads a `JSON::Any` value from the given pull parser.

## Instance Method Detail

def ==(other) #

Returns `true` if the raw object is equal to other.

def ==(other : JSON::Any) #

Returns `true` if both `self` and other's raw object are equal.

def [](index : Int) : JSON::Any #

Assumes the underlying value is an `Array` and returns the element at the given index. Raises if the underlying value is not an `Array`.

def [](key : String) : JSON::Any #

Assumes the underlying value is a `Hash` and returns the element with the given key. Raises if the underlying value is not a `Hash`.

def []?(index : Int) : JSON::Any? #

Assumes the underlying value is an `Array` and returns the element at the given index, or `nil` if out of bounds. Raises if the underlying value is not an `Array`.

def []?(key : String) : JSON::Any? #

Assumes the underlying value is a `Hash` and returns the element with the given key, or `nil` if the key is not present. Raises if the underlying value is not a `Hash`.

def as_a : Array(Type) #

Checks that the underlying value is `Array`, and returns its value. Raises otherwise.

def as_a? : Array(Type)? #

Checks that the underlying value is `Array`, and returns its value. Returns `nil` otherwise.

def as_bool : Bool #

Checks that the underlying value is `Bool`, and returns its value. Raises otherwise.

def as_bool? : Bool? #

Checks that the underlying value is `Bool`, and returns its value. Returns `nil` otherwise.

def as_f : Float64 #

Checks that the underlying value is `Float`, and returns its value as an `Float64`. Raises otherwise.

def as_f32 : Float32 #

Checks that the underlying value is `Float`, and returns its value as an `Float32`. Raises otherwise.

def as_f32? : Float32? #

Checks that the underlying value is `Float`, and returns its value as an `Float32`. Returns `nil` otherwise.

def as_f? : Float64? #

Checks that the underlying value is `Float`, and returns its value as an `Float64`. Returns `nil` otherwise.

def as_h : Hash(String, Type) #

Checks that the underlying value is `Hash`, and returns its value. Raises otherwise.

def as_h? : Hash(String, Type)? #

Checks that the underlying value is `Hash`, and returns its value. Returns `nil` otherwise.

def as_i : Int32 #

Checks that the underlying value is `Int`, and returns its value as an `Int32`. Raises otherwise.

def as_i64 : Int64 #

Checks that the underlying value is `Int`, and returns its value as an `Int64`. Raises otherwise.

def as_i64? : Int64? #

Checks that the underlying value is `Int`, and returns its value as an `Int64`. Returns `nil` otherwise.

def as_i? : Int32? #

Checks that the underlying value is `Int`, and returns its value as an `Int32`. Returns `nil` otherwise.

def as_nil : Nil #

Checks that the underlying value is `Nil`, and returns `nil`. Raises otherwise.

def as_s : String #

Checks that the underlying value is `String`, and returns its value. Raises otherwise.

def as_s? : String? #

Checks that the underlying value is `String`, and returns its value. Returns `nil` otherwise.

def each(&block) #

Assumes the underlying value is an `Array` or `Hash` and yields each of the elements or key/values, always as `JSON::Any`. Raises if the underlying value is not an `Array` or `Hash`.

def raw : JSON::Type #

Returns the raw underlying value, a `JSON::Type`.

def size : Int #

Assumes the underlying value is an `Array` or `Hash` and returns its size. Raises if the underlying value is not an `Array` or `Hash`.